- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# os_nova_flavor – Manage OpenStack compute flavors

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Add or remove flavors from OpenStack.

## Requirements

The below requirements are needed on the host that executes this module.

- openstacksdk
- openstacksdk >= 0.12.0
- python >= 2.7

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_timeout integer |  | How long should the socket layer wait before timing out for API calls. If this is omitted, nothing will be passed to the requests library.
auth dictionary |  | Dictionary containing auth information as needed by the cloud's auth plugin strategy. For the default password plugin, this would contain auth_url, username, password, project_name and any information about domains (for example, os_user_domain_name or os_project_domain_name) if the cloud supports them. For other plugins, this param will need to contain whatever parameters that auth plugin requires. This parameter is not needed if a named cloud is provided or OpenStack OS_* environment variables are present.
auth_type string |  | Name of the auth plugin to use. If the cloud uses something other than password authentication, the name of the plugin should be indicated here and the contents of the auth parameter should be updated accordingly.
availability_zone - |  | Ignored. Present for backwards compatibility
ca_cert string |  | A path to a CA Cert bundle that can be used as part of verifying SSL API requests. aliases: cacert
client_cert string |  | A path to a client certificate to use as part of the SSL transaction. aliases: cert
client_key string |  | A path to a client key to use as part of the SSL transaction. aliases: key
cloud raw |  | Named cloud or cloud config to operate against. If cloud is a string, it references a named cloud config as defined in an OpenStack clouds.yaml file. Provides default values for auth and auth_type. This parameter is not needed if auth is provided or if OpenStack OS_* environment variables are present. If cloud is a dict, it contains a complete cloud configuration like would be in a section of clouds.yaml.
disk - |  | Size of local disk, in GB.
ephemeral - | Default: 0 | Ephemeral space size, in GB.
extra_specs - |  | Metadata dictionary
flavorid - | Default: "auto" | ID for the flavor. This is optional as a unique UUID will be assigned if a value is not specified.
interface string | Choices: admin internal public ← | Endpoint URL type to fetch from the service catalog. aliases: endpoint_type
is_public boolean | Choices: no yes ← | Make flavor accessible to the public.
name - / required |  | Flavor name.
ram - |  | Amount of memory, in MB.
region_name string |  | Name of the region.
rxtx_factor - | Default: 1.0 | RX/TX factor.
state - | Choices: present ← absent | Indicate desired state of the resource. When state is 'present', then ram, vcpus, and disk are all required. There are no default values for those parameters.
swap - | Default: 0 | Swap space size, in MB.
timeout integer | Default: 180 | How long should ansible wait for the requested resource.
validate_certs boolean | Choices: no ← yes | Whether or not SSL API requests should be verified. Before Ansible 2.3 this defaulted to `yes`. aliases: verify
vcpus - |  | Number of virtual CPUs.
wait boolean | Choices: no yes ← | Should ansible wait until the requested resource is complete.

## Notes

Note

- The standard OpenStack environment variables, such as `OS_USERNAME` may be used instead of providing explicit values.
- Auth information is driven by openstacksdk, which means that values can come from a yaml config file in /etc/ansible/openstack.yaml, /etc/openstack/clouds.yaml or ~/.config/openstack/clouds.yaml, then from standard environment variables, then finally by explicit parameters in plays. More information can be found at https://docs.openstack.org/openstacksdk/

## Examples

    - name: "Create 'tiny' flavor with 1024MB of RAM, 1 virtual CPU, and 10GB of local disk, and 10GB of ephemeral."
      os_nova_flavor:
        cloud: mycloud
        state: present
        name: tiny
        ram: 1024
        vcpus: 1
        disk: 10
        ephemeral: 10

    - name: "Delete 'tiny' flavor"
      os_nova_flavor:
        cloud: mycloud
        state: absent
        name: tiny

    - name: Create flavor with metadata
      os_nova_flavor:
        cloud: mycloud
        state: present
        name: tiny
        ram: 1024
        vcpus: 1
        disk: 10
        extra_specs:
          "quota:disk_read_iops_sec": 5000
          "aggregate_instance_extra_specs:pinned": false

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
flavor complex | On success when state is 'present' | Dictionary describing the flavor.
| disk integer | success | Size of local disk, in GB. Sample: 10
| ephemeral integer | success | Ephemeral space size, in GB. Sample: 10
| extra_specs dictionary | success | Flavor metadata Sample: {'quota:disk_read_iops_sec': 5000, 'aggregate_instance_extra_specs:pinned': False}
| id string | success | Flavor ID. Sample: 515256b8-7027-4d73-aa54-4e30a4a4a339
| is_public boolean | success | Make flavor accessible to the public. Sample: True
| name string | success | Flavor name. Sample: tiny
| ram integer | success | Amount of memory, in MB. Sample: 1024
| swap integer | success | Swap space size, in MB. Sample: 100
| vcpus integer | success | Number of virtual CPUs. Sample: 2

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- David Shrewsbury (@Shrews)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.